HDU 1087 Super Jumping! Jumping! Jumping!

E - Super Jumping! Jumping! Jumping!

HDU - 1087

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.



The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.
Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
Output
For each case, print the maximum according to rules, and one line one case.
Sample Input
3 1 3 2
4 1 2 3 4
4 3 3 2 1
0
Sample Output
4
10
3

dp的入门级别题目,刚开始感觉好别扭,习惯了之后发现其实没那么难

题意是这样的,从起点开始跳,每次只能跳比当前大的数,可以隔着跳,得分是所有跳过的数的加和,最后问最大的和是多少

这道题从第一个点开始找当前情况下最优解

#include<iostream>
#include<cstring>
#include<cstdio>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<queue>
#include<cmath>
using namespace std;
#define miny 0x3f3f3f3f
int maxy[1010];//记录当前的最大递增子序列
int num[1010];//记录的是输入的数
int main()
{
    int n;
    while(scanf("%d",&n)!=EOF&&n)
    {
        memset(maxy, 0, sizeof(maxy));
        for(int i = 1; i <= n; i ++)
            scanf("%d",&num[i]);
        for(int i = 1; i <= n; i ++)//逐个点遍历探索最优解
            for(int j = 0; j < i; j ++)
            {
                if(num[i] > num[j])//后面的数大于前面时才能继续判断
                    maxy[i] = max(maxy[i], maxy[j] + num[i]);//不断更新每个点的最优解
            }
        int ans = -miny;
        for(int i = 1; i <= n; i ++)
            if(maxy[i] > ans)
            ans = maxy[i];
        printf("%d\n",ans);
    }
    return 0;
}

其实真的是没有那么难,dp的思想一定要掌握

题外话,这道题刚开始想着用dfs做,想着每一步有两种选择,即加上或者不加,不过后来敲出代码来就发现弊端了,就是无法判断是否能判断是否应该加上这个数,挂一下错误代码长个记性

#include<iostream>
#include<cstring>
#include<cstdio>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<queue>
#include<cmath>
using namespace std;
#define miny 0x3f3f3f3f
int maxy[10010];//记录当前的最大递增子序列
int num[10010];//记录的是输入的数
int ans, i, m;
void dfs(int n)
{
    if(n > ans) ans = n;
    if(i == m + 1) return ;
    if(num[i] > num[i - 1])//***问题就出在这里了。。。压根没法判断是否应该加上***
    {
        i ++;
        dfs(ans + num[i]);
        dfs(ans);
    }
}
int main()
{
    while(scanf("%d",&m)!=EOF&&m)
    {
        memset(maxy, 0, sizeof(maxy));
        for(int j = 1; j <= m; j ++)
            scanf("%d",&num[j]);
        ans = 0;
        i = 1;
        dfs(0);
        printf("%d\n",ans);
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值